# Encoding: utf-8
#
# This is auto-generated code, changes will be overwritten.
#
# Copyright:: Copyright 2021, Google Inc. All Rights Reserved.
# License:: Licensed under the Apache License, Version 2.0.
#
# Code generated by AdsCommon library 1.0.2 on 2021-02-12 12:59:03.

require 'ad_manager_api/errors'

module AdManagerApi; module V202102; module CreativeService
  class CreativeServiceRegistry
    CREATIVESERVICE_METHODS = {:create_creatives=>{:input=>[{:name=>:creatives, :type=>"Creative", :min_occurs=>0, :max_occurs=>:unbounded}], :output=>{:name=>"create_creatives_response", :fields=>[{:name=>:rval, :type=>"Creative", :min_occurs=>0, :max_occurs=>:unbounded}]}}, :get_creatives_by_statement=>{:input=>[{:name=>:filter_statement, :type=>"Statement", :min_occurs=>0, :max_occurs=>1}], :output=>{:name=>"get_creatives_by_statement_response", :fields=>[{:name=>:rval, :type=>"CreativePage", :min_occurs=>0, :max_occurs=>1}]}}, :perform_creative_action=>{:input=>[{:name=>:creative_action, :type=>"CreativeAction", :min_occurs=>0, :max_occurs=>1}, {:name=>:filter_statement, :type=>"Statement", :min_occurs=>0, :max_occurs=>1}], :output=>{:name=>"perform_creative_action_response", :fields=>[{:name=>:rval, :type=>"UpdateResult", :min_occurs=>0, :max_occurs=>1}]}}, :update_creatives=>{:input=>[{:name=>:creatives, :type=>"Creative", :min_occurs=>0, :max_occurs=>:unbounded}], :output=>{:name=>"update_creatives_response", :fields=>[{:name=>:rval, :type=>"Creative", :min_occurs=>0, :max_occurs=>:unbounded}]}}}
    CREATIVESERVICE_TYPES = {:BaseDynamicAllocationCreative=>{:fields=>[], :abstract=>true, :base=>"Creative"}, :BaseCreativeTemplateVariableValue=>{:fields=>[{:name=>:unique_name, :type=>"string", :min_occurs=>0, :max_occurs=>1}], :abstract=>true}, :ObjectValue=>{:fields=>[], :abstract=>true, :base=>"Value"}, :ActivateCreatives=>{:fields=>[], :base=>"CreativeAction"}, :AdExchangeCreative=>{:fields=>[{:name=>:is_native_eligible, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}, {:name=>:is_interstitial, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}], :base=>"HasHtmlSnippetDynamicAllocationCreative"}, :AdSenseCreative=>{:fields=>[], :base=>"HasHtmlSnippetDynamicAllocationCreative"}, :ApiError=>{:fields=>[{:name=>:field_path, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:field_path_elements, :type=>"FieldPathElement", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:trigger, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:error_string, :type=>"string", :min_occurs=>0, :max_occurs=>1}], :abstract=>true}, :ApiException=>{:fields=>[{:name=>:errors, :type=>"ApiError", :min_occurs=>0, :max_occurs=>:unbounded}], :base=>"ApplicationException"}, :ApiVersionError=>{:fields=>[{:name=>:reason, :type=>"ApiVersionError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :ApplicationException=>{:fields=>[{:name=>:message, :type=>"string", :min_occurs=>0, :max_occurs=>1}]}, :AppliedLabel=>{:fields=>[{:name=>:label_id, :type=>"long", :min_occurs=>0, :max_occurs=>1}, {:name=>:is_negated, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}]}, :AspectRatioImageCreative=>{:fields=>[{:name=>:image_assets, :type=>"CreativeAsset", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:alt_text, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:third_party_impression_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:override_size, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}], :base=>"HasDestinationUrlCreative"}, :AssetCreativeTemplateVariableValue=>{:fields=>[{:name=>:asset, :type=>"CreativeAsset", :min_occurs=>0, :max_occurs=>1}], :base=>"BaseCreativeTemplateVariableValue"}, :Asset=>{:fields=>[], :abstract=>true}, :AssetError=>{:fields=>[{:name=>:reason, :type=>"AssetError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :AudioCreative=>{:fields=>[], :base=>"BaseAudioCreative"}, :AudioRedirectCreative=>{:fields=>[{:name=>:audio_assets, :type=>"VideoRedirectAsset", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:mezzanine_file, :type=>"VideoRedirectAsset", :min_occurs=>0, :max_occurs=>1}], :base=>"BaseAudioCreative"}, :AuthenticationError=>{:fields=>[{:name=>:reason, :type=>"AuthenticationError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :BaseAudioCreative=>{:fields=>[{:name=>:duration, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:allow_duration_override, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}, {:name=>:tracking_urls, :type=>"ConversionEvent_TrackingUrlsMapEntry", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:companion_creative_ids, :type=>"long", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:custom_parameters, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:ad_id, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:ad_id_type, :type=>"AdIdType", :min_occurs=>0, :max_occurs=>1}, {:name=>:skippable_ad_type, :type=>"SkippableAdType", :min_occurs=>0, :max_occurs=>1}, {:name=>:vast_preview_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:ssl_scan_result, :type=>"SslScanResult", :min_occurs=>0, :max_occurs=>1}, {:name=>:ssl_manual_override, :type=>"SslManualOverride", :min_occurs=>0, :max_occurs=>1}], :abstract=>true, :base=>"HasDestinationUrlCreative"}, :BaseCustomFieldValue=>{:fields=>[{:name=>:custom_field_id, :type=>"long", :min_occurs=>0, :max_occurs=>1}], :abstract=>true}, :BaseImageCreative=>{:fields=>[{:name=>:override_size, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}, {:name=>:primary_image_asset, :type=>"CreativeAsset", :min_occurs=>0, :max_occurs=>1}], :abstract=>true, :base=>"HasDestinationUrlCreative"}, :BaseImageRedirectCreative=>{:fields=>[{:name=>:image_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}], :abstract=>true, :base=>"HasDestinationUrlCreative"}, :BaseRichMediaStudioCreative=>{:fields=>[{:name=>:studio_creative_id, :type=>"long", :min_occurs=>0, :max_occurs=>1}, {:name=>:creative_format, :type=>"RichMediaStudioCreativeFormat", :min_occurs=>0, :max_occurs=>1}, {:name=>:artwork_type, :type=>"RichMediaStudioCreativeArtworkType", :min_occurs=>0, :max_occurs=>1}, {:name=>:total_file_size, :type=>"long", :min_occurs=>0, :max_occurs=>1}, {:name=>:ad_tag_keys, :type=>"string", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:custom_key_values, :type=>"string", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:survey_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:all_impressions_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:rich_media_impressions_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:backup_image_impressions_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:override_css, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:required_flash_plugin_version, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:duration, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:billing_attribute, :type=>"RichMediaStudioCreativeBillingAttribute", :min_occurs=>0, :max_occurs=>1}, {:name=>:rich_media_studio_child_asset_properties, :type=>"RichMediaStudioChildAssetProperty", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:ssl_scan_result, :type=>"SslScanResult", :min_occurs=>0, :max_occurs=>1}, {:name=>:ssl_manual_override, :type=>"SslManualOverride", :min_occurs=>0, :max_occurs=>1}], :abstract=>true, :base=>"Creative"}, :BaseVideoCreative=>{:fields=>[{:name=>:duration, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:allow_duration_override, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}, {:name=>:tracking_urls, :type=>"ConversionEvent_TrackingUrlsMapEntry", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:companion_creative_ids, :type=>"long", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:custom_parameters, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:ad_id, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:ad_id_type, :type=>"AdIdType", :min_occurs=>0, :max_occurs=>1}, {:name=>:skippable_ad_type, :type=>"SkippableAdType", :min_occurs=>0, :max_occurs=>1}, {:name=>:vast_preview_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:ssl_scan_result, :type=>"SslScanResult", :min_occurs=>0, :max_occurs=>1}, {:name=>:ssl_manual_override, :type=>"SslManualOverride", :min_occurs=>0, :max_occurs=>1}], :abstract=>true, :base=>"HasDestinationUrlCreative"}, :BooleanValue=>{:fields=>[{:name=>:value, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}], :base=>"Value"}, :ClickTag=>{:fields=>[{:name=>:name, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:url, :type=>"string", :min_occurs=>0, :max_occurs=>1}]}, :ClickTrackingCreative=>{:fields=>[{:name=>:click_tracking_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}], :base=>"Creative"}, :CollectionSizeError=>{:fields=>[{:name=>:reason, :type=>"CollectionSizeError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :CommonError=>{:fields=>[{:name=>:reason, :type=>"CommonError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :ConversionEvent_TrackingUrlsMapEntry=>{:fields=>[{:name=>:key, :type=>"ConversionEvent", :min_occurs=>0, :max_occurs=>1}, {:name=>:value, :type=>"TrackingUrls", :min_occurs=>0, :max_occurs=>1}]}, :CreativeAction=>{:fields=>[], :abstract=>true}, :CreativeAsset=>{:fields=>[{:name=>:asset_id, :type=>"long", :min_occurs=>0, :max_occurs=>1}, {:name=>:asset_byte_array, :type=>"base64Binary", :min_occurs=>0, :max_occurs=>1}, {:name=>:file_name, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:file_size, :type=>"long", :min_occurs=>0, :max_occurs=>1}, {:name=>:asset_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:size, :type=>"Size", :min_occurs=>0, :max_occurs=>1}, {:name=>:click_tags, :type=>"ClickTag", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:image_density, :type=>"ImageDensity", :min_occurs=>0, :max_occurs=>1}]}, :CustomCreativeAsset=>{:fields=>[{:name=>:macro_name, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:asset, :type=>"CreativeAsset", :min_occurs=>0, :max_occurs=>1}]}, :CreativeAssetMacroError=>{:fields=>[{:name=>:reason, :type=>"CreativeAssetMacroError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :Creative=>{:fields=>[{:name=>:advertiser_id, :type=>"long", :min_occurs=>0, :max_occurs=>1}, {:name=>:id, :type=>"long", :min_occurs=>0, :max_occurs=>1}, {:name=>:name, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:size, :type=>"Size", :min_occurs=>0, :max_occurs=>1}, {:name=>:preview_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:policy_labels, :type=>"CreativePolicyViolation", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:applied_labels, :type=>"AppliedLabel", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:last_modified_date_time, :type=>"DateTime", :min_occurs=>0, :max_occurs=>1}, {:name=>:custom_field_values, :type=>"BaseCustomFieldValue", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:third_party_data_declaration, :type=>"ThirdPartyDataDeclaration", :min_occurs=>0, :max_occurs=>1}], :abstract=>true}, :CreativeError=>{:fields=>[{:name=>:reason, :type=>"CreativeError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :CreativePage=>{:fields=>[{:name=>:total_result_set_size, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:start_index, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:results, :type=>"Creative", :min_occurs=>0, :max_occurs=>:unbounded}]}, :CreativeSetError=>{:fields=>[{:name=>:reason, :type=>"CreativeSetError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :CreativeTemplateError=>{:fields=>[{:name=>:reason, :type=>"CreativeTemplateError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :CreativeTemplateOperationError=>{:fields=>[{:name=>:reason, :type=>"CreativeTemplateOperationError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :CustomCreative=>{:fields=>[{:name=>:html_snippet, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:custom_creative_assets, :type=>"CustomCreativeAsset", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:is_interstitial, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}, {:name=>:locked_orientation, :type=>"LockedOrientation", :min_occurs=>0, :max_occurs=>1}, {:name=>:ssl_scan_result, :type=>"SslScanResult", :min_occurs=>0, :max_occurs=>1}, {:name=>:ssl_manual_override, :type=>"SslManualOverride", :min_occurs=>0, :max_occurs=>1}, {:name=>:is_safe_frame_compatible, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}, {:name=>:third_party_impression_tracking_urls, :type=>"string", :min_occurs=>0, :max_occurs=>:unbounded}], :base=>"HasDestinationUrlCreative"}, :CustomCreativeError=>{:fields=>[{:name=>:reason, :type=>"CustomCreativeError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :CustomFieldValue=>{:fields=>[{:name=>:value, :type=>"Value", :min_occurs=>0, :max_occurs=>1}], :base=>"BaseCustomFieldValue"}, :CustomFieldValueError=>{:fields=>[{:name=>:reason, :type=>"CustomFieldValueError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :Date=>{:fields=>[{:name=>:year, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:month, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:day, :type=>"int", :min_occurs=>0, :max_occurs=>1}]}, :DateTime=>{:fields=>[{:name=>:date, :type=>"Date", :min_occurs=>0, :max_occurs=>1}, {:name=>:hour, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:minute, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:second, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:time_zone_id, :type=>"string", :min_occurs=>0, :max_occurs=>1}]}, :DateTimeValue=>{:fields=>[{:name=>:value, :type=>"DateTime", :min_occurs=>0, :max_occurs=>1}], :base=>"Value"}, :DateValue=>{:fields=>[{:name=>:value, :type=>"Date", :min_occurs=>0, :max_occurs=>1}], :base=>"Value"}, :DeactivateCreatives=>{:fields=>[], :base=>"CreativeAction"}, :DropDownCustomFieldValue=>{:fields=>[{:name=>:custom_field_option_id, :type=>"long", :min_occurs=>0, :max_occurs=>1}], :base=>"BaseCustomFieldValue"}, :EntityLimitReachedError=>{:fields=>[{:name=>:reason, :type=>"EntityLimitReachedError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :FeatureError=>{:fields=>[{:name=>:reason, :type=>"FeatureError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :FieldPathElement=>{:fields=>[{:name=>:field, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:index, :type=>"int", :min_occurs=>0, :max_occurs=>1}]}, :FileError=>{:fields=>[{:name=>:reason, :type=>"FileError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :HasDestinationUrlCreative=>{:fields=>[{:name=>:destination_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:destination_url_type, :type=>"DestinationUrlType", :min_occurs=>0, :max_occurs=>1}], :abstract=>true, :base=>"Creative"}, :HasHtmlSnippetDynamicAllocationCreative=>{:fields=>[{:name=>:code_snippet, :type=>"string", :min_occurs=>0, :max_occurs=>1}], :abstract=>true, :base=>"BaseDynamicAllocationCreative"}, :Html5Creative=>{:fields=>[{:name=>:override_size, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}, {:name=>:third_party_impression_tracking_urls, :type=>"string", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:third_party_click_tracking_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:locked_orientation, :type=>"LockedOrientation", :min_occurs=>0, :max_occurs=>1}, {:name=>:ssl_scan_result, :type=>"SslScanResult", :min_occurs=>0, :max_occurs=>1}, {:name=>:ssl_manual_override, :type=>"SslManualOverride", :min_occurs=>0, :max_occurs=>1}, {:name=>:is_safe_frame_compatible, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}, {:name=>:html5_asset, :type=>"CreativeAsset", :min_occurs=>0, :max_occurs=>1}], :base=>"Creative"}, :HtmlBundleProcessorError=>{:fields=>[{:name=>:reason, :type=>"HtmlBundleProcessorError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :ImageCreative=>{:fields=>[{:name=>:alt_text, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:third_party_impression_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:secondary_image_assets, :type=>"CreativeAsset", :min_occurs=>0, :max_occurs=>:unbounded}], :base=>"BaseImageCreative"}, :ImageError=>{:fields=>[{:name=>:reason, :type=>"ImageError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :ImageOverlayCreative=>{:fields=>[{:name=>:companion_creative_ids, :type=>"long", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:tracking_urls, :type=>"ConversionEvent_TrackingUrlsMapEntry", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:locked_orientation, :type=>"LockedOrientation", :min_occurs=>0, :max_occurs=>1}, {:name=>:custom_parameters, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:duration, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:vast_preview_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}], :base=>"BaseImageCreative"}, :ImageRedirectCreative=>{:fields=>[{:name=>:alt_text, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:third_party_impression_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}], :base=>"BaseImageRedirectCreative"}, :ImageRedirectOverlayCreative=>{:fields=>[{:name=>:asset_size, :type=>"Size", :min_occurs=>0, :max_occurs=>1}, {:name=>:duration, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:companion_creative_ids, :type=>"long", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:tracking_urls, :type=>"ConversionEvent_TrackingUrlsMapEntry", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:custom_parameters, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:vast_preview_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}], :base=>"BaseImageRedirectCreative"}, :InternalApiError=>{:fields=>[{:name=>:reason, :type=>"InternalApiError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :InternalRedirectCreative=>{:fields=>[{:name=>:locked_orientation, :type=>"LockedOrientation", :min_occurs=>0, :max_occurs=>1}, {:name=>:asset_size, :type=>"Size", :min_occurs=>0, :max_occurs=>1}, {:name=>:internal_redirect_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:override_size, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}, {:name=>:is_interstitial, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}, {:name=>:ssl_scan_result, :type=>"SslScanResult", :min_occurs=>0, :max_occurs=>1}, {:name=>:ssl_manual_override, :type=>"SslManualOverride", :min_occurs=>0, :max_occurs=>1}, {:name=>:third_party_impression_tracking_urls, :type=>"string", :min_occurs=>0, :max_occurs=>:unbounded}], :base=>"Creative"}, :InvalidPhoneNumberError=>{:fields=>[{:name=>:reason, :type=>"InvalidPhoneNumberError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :InvalidUrlError=>{:fields=>[{:name=>:reason, :type=>"InvalidUrlError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :LabelEntityAssociationError=>{:fields=>[{:name=>:reason, :type=>"LabelEntityAssociationError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :LegacyDfpCreative=>{:fields=>[], :base=>"Creative"}, :LineItemCreativeAssociationError=>{:fields=>[{:name=>:reason, :type=>"LineItemCreativeAssociationError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :LongCreativeTemplateVariableValue=>{:fields=>[{:name=>:value, :type=>"long", :min_occurs=>0, :max_occurs=>1}], :base=>"BaseCreativeTemplateVariableValue"}, :NotNullError=>{:fields=>[{:name=>:reason, :type=>"NotNullError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :NullError=>{:fields=>[{:name=>:reason, :type=>"NullError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :NumberValue=>{:fields=>[{:name=>:value, :type=>"string", :min_occurs=>0, :max_occurs=>1}], :base=>"Value"}, :ParseError=>{:fields=>[{:name=>:reason, :type=>"ParseError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :PermissionError=>{:fields=>[{:name=>:reason, :type=>"PermissionError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :ProgrammaticCreative=>{:fields=>[], :base=>"Creative"}, :PublisherQueryLanguageContextError=>{:fields=>[{:name=>:reason, :type=>"PublisherQueryLanguageContextError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :PublisherQueryLanguageSyntaxError=>{:fields=>[{:name=>:reason, :type=>"PublisherQueryLanguageSyntaxError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :QuotaError=>{:fields=>[{:name=>:reason, :type=>"QuotaError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :RangeError=>{:fields=>[{:name=>:reason, :type=>"RangeError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :RedirectAsset=>{:fields=>[{:name=>:redirect_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}], :abstract=>true, :base=>"Asset"}, :RequiredCollectionError=>{:fields=>[{:name=>:reason, :type=>"RequiredCollectionError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :RequiredError=>{:fields=>[{:name=>:reason, :type=>"RequiredError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :RequiredNumberError=>{:fields=>[{:name=>:reason, :type=>"RequiredNumberError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :RequiredSizeError=>{:fields=>[{:name=>:reason, :type=>"RequiredSizeError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :RichMediaStudioChildAssetProperty=>{:fields=>[{:name=>:name, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:type, :type=>"RichMediaStudioChildAssetProperty.Type", :min_occurs=>0, :max_occurs=>1}, {:name=>:total_file_size, :type=>"long", :min_occurs=>0, :max_occurs=>1}, {:name=>:width, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:height, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:url, :type=>"string", :min_occurs=>0, :max_occurs=>1}]}, :RichMediaStudioCreative=>{:fields=>[{:name=>:locked_orientation, :type=>"LockedOrientation", :min_occurs=>0, :max_occurs=>1}, {:name=>:is_interstitial, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}], :base=>"BaseRichMediaStudioCreative"}, :RichMediaStudioCreativeError=>{:fields=>[{:name=>:reason, :type=>"RichMediaStudioCreativeError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :ServerError=>{:fields=>[{:name=>:reason, :type=>"ServerError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :SetTopBoxCreative=>{:fields=>[{:name=>:external_asset_id, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:provider_id, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:availability_region_ids, :type=>"string", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:license_window_start_date_time, :type=>"DateTime", :min_occurs=>0, :max_occurs=>1}, {:name=>:license_window_end_date_time, :type=>"DateTime", :min_occurs=>0, :max_occurs=>1}], :base=>"BaseVideoCreative"}, :SetTopBoxCreativeError=>{:fields=>[{:name=>:reason, :type=>"SetTopBoxCreativeError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :SetValue=>{:fields=>[{:name=>:values, :type=>"Value", :min_occurs=>0, :max_occurs=>:unbounded}], :base=>"Value"}, :Size=>{:fields=>[{:name=>:width, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:height, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:is_aspect_ratio, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}]}, :SoapRequestHeader=>{:fields=>[{:name=>:network_code, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:application_name, :type=>"string", :min_occurs=>0, :max_occurs=>1}]}, :SoapResponseHeader=>{:fields=>[{:name=>:request_id, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:response_time, :type=>"long", :min_occurs=>0, :max_occurs=>1}]}, :Statement=>{:fields=>[{:name=>:query, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:values, :type=>"String_ValueMapEntry", :min_occurs=>0, :max_occurs=>:unbounded}]}, :StatementError=>{:fields=>[{:name=>:reason, :type=>"StatementError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :StringCreativeTemplateVariableValue=>{:fields=>[{:name=>:value, :type=>"string", :min_occurs=>0, :max_occurs=>1}], :base=>"BaseCreativeTemplateVariableValue"}, :StringFormatError=>{:fields=>[{:name=>:reason, :type=>"StringFormatError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :StringLengthError=>{:fields=>[{:name=>:reason, :type=>"StringLengthError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :String_ValueMapEntry=>{:fields=>[{:name=>:key, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:value, :type=>"Value", :min_occurs=>0, :max_occurs=>1}]}, :SwiffyConversionError=>{:fields=>[{:name=>:reason, :type=>"SwiffyConversionError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :TemplateCreative=>{:fields=>[{:name=>:creative_template_id, :type=>"long", :min_occurs=>0, :max_occurs=>1}, {:name=>:is_interstitial, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}, {:name=>:is_native_eligible, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}, {:name=>:is_safe_frame_compatible, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}, {:name=>:destination_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:creative_template_variable_values, :type=>"BaseCreativeTemplateVariableValue", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:ssl_scan_result, :type=>"SslScanResult", :min_occurs=>0, :max_occurs=>1}, {:name=>:ssl_manual_override, :type=>"SslManualOverride", :min_occurs=>0, :max_occurs=>1}, {:name=>:locked_orientation, :type=>"LockedOrientation", :min_occurs=>0, :max_occurs=>1}], :base=>"Creative"}, :TemplateInstantiatedCreativeError=>{:fields=>[{:name=>:reason, :type=>"TemplateInstantiatedCreativeError.Reason", :min_occurs=>0, :max_occurs=>1}], :base=>"ApiError"}, :TextValue=>{:fields=>[{:name=>:value, :type=>"string", :min_occurs=>0, :max_occurs=>1}], :base=>"Value"}, :ThirdPartyCreative=>{:fields=>[{:name=>:snippet, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:expanded_snippet, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:ssl_scan_result, :type=>"SslScanResult", :min_occurs=>0, :max_occurs=>1}, {:name=>:ssl_manual_override, :type=>"SslManualOverride", :min_occurs=>0, :max_occurs=>1}, {:name=>:locked_orientation, :type=>"LockedOrientation", :min_occurs=>0, :max_occurs=>1}, {:name=>:is_safe_frame_compatible, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}, {:name=>:third_party_impression_tracking_urls, :type=>"string", :min_occurs=>0, :max_occurs=>:unbounded}], :base=>"Creative"}, :ThirdPartyDataDeclaration=>{:fields=>[{:name=>:declaration_type, :type=>"DeclarationType", :min_occurs=>0, :max_occurs=>1}, {:name=>:third_party_company_ids, :type=>"long", :min_occurs=>0, :max_occurs=>:unbounded}]}, :TrackingUrls=>{:fields=>[{:name=>:urls, :type=>"string", :min_occurs=>0, :max_occurs=>:unbounded}]}, :TypeError=>{:fields=>[], :base=>"ApiError"}, :UniqueError=>{:fields=>[], :base=>"ApiError"}, :UnsupportedCreative=>{:fields=>[{:name=>:unsupported_creative_type, :type=>"string", :min_occurs=>0, :max_occurs=>1}], :base=>"Creative"}, :UpdateResult=>{:fields=>[{:name=>:num_changes, :type=>"int", :min_occurs=>0, :max_occurs=>1}]}, :UrlCreativeTemplateVariableValue=>{:fields=>[{:name=>:value, :type=>"string", :min_occurs=>0, :max_occurs=>1}], :base=>"BaseCreativeTemplateVariableValue"}, :Value=>{:fields=>[], :abstract=>true}, :VastRedirectCreative=>{:fields=>[{:name=>:vast_xml_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:vast_redirect_type, :type=>"VastRedirectType", :min_occurs=>0, :max_occurs=>1}, {:name=>:duration, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:companion_creative_ids, :type=>"long", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:tracking_urls, :type=>"ConversionEvent_TrackingUrlsMapEntry", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:vast_preview_url, :type=>"string", :min_occurs=>0, :max_occurs=>1}, {:name=>:ssl_scan_result, :type=>"SslScanResult", :min_occurs=>0, :max_occurs=>1}, {:name=>:ssl_manual_override, :type=>"SslManualOverride", :min_occurs=>0, :max_occurs=>1}, {:name=>:is_audio, :type=>"boolean", :min_occurs=>0, :max_occurs=>1}], :base=>"Creative"}, :VideoCreative=>{:fields=>[], :base=>"BaseVideoCreative"}, :VideoMetadata=>{:fields=>[{:name=>:scalable_type, :type=>"ScalableType", :min_occurs=>0, :max_occurs=>1}, {:name=>:duration, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:bit_rate, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:minimum_bit_rate, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:maximum_bit_rate, :type=>"int", :min_occurs=>0, :max_occurs=>1}, {:name=>:size, :type=>"Size", :min_occurs=>0, :max_occurs=>1}, {:name=>:mime_type, :type=>"MimeType", :min_occurs=>0, :max_occurs=>1}, {:name=>:delivery_type, :type=>"VideoDeliveryType", :min_occurs=>0, :max_occurs=>1}, {:name=>:codecs, :type=>"string", :min_occurs=>0, :max_occurs=>:unbounded}]}, :VideoRedirectAsset=>{:fields=>[{:name=>:metadata, :type=>"VideoMetadata", :min_occurs=>0, :max_occurs=>1}], :base=>"RedirectAsset"}, :VideoRedirectCreative=>{:fields=>[{:name=>:video_assets, :type=>"VideoRedirectAsset", :min_occurs=>0, :max_occurs=>:unbounded}, {:name=>:mezzanine_file, :type=>"VideoRedirectAsset", :min_occurs=>0, :max_occurs=>1}], :base=>"BaseVideoCreative"}, :AdIdType=>{:type=>"string", :enumerations=>["UNKNOWN", "AD_ID", "CLEARCAST", "NONE"]}, :"ApiVersionError.Reason"=>{:type=>"string", :enumerations=>["UPDATE_TO_NEWER_VERSION", "UNKNOWN"]}, :"AssetError.Reason"=>{:type=>"string", :enumerations=>["NON_UNIQUE_NAME", "FILE_NAME_TOO_LONG", "FILE_SIZE_TOO_LARGE", "MISSING_REQUIRED_DYNAMIC_ALLOCATION_CLIENT", "MISSING_REQUIRED_DYNAMIC_ALLOCATION_HEIGHT", "MISSING_REQUIRED_DYNAMIC_ALLOCATION_WIDTH", "MISSING_REQUIRED_DYNAMIC_ALLOCATION_FORMAT", "INVALID_CODE_SNIPPET_PARAMETER_VALUE", "INVALID_ASSET_ID", "UNKNOWN"]}, :"AuthenticationError.Reason"=>{:type=>"string", :enumerations=>["AMBIGUOUS_SOAP_REQUEST_HEADER", "INVALID_EMAIL", "AUTHENTICATION_FAILED", "INVALID_OAUTH_SIGNATURE", "INVALID_SERVICE", "MISSING_SOAP_REQUEST_HEADER", "MISSING_AUTHENTICATION_HTTP_HEADER", "MISSING_AUTHENTICATION", "NETWORK_API_ACCESS_DISABLED", "NO_NETWORKS_TO_ACCESS", "NETWORK_NOT_FOUND", "NETWORK_CODE_REQUIRED", "CONNECTION_ERROR", "GOOGLE_ACCOUNT_ALREADY_ASSOCIATED_WITH_NETWORK", "UNDER_INVESTIGATION", "UNKNOWN"]}, :"CollectionSizeError.Reason"=>{:type=>"string", :enumerations=>["TOO_LARGE", "UNKNOWN"]}, :"CommonError.Reason"=>{:type=>"string", :enumerations=>["NOT_FOUND", "ALREADY_EXISTS", "NOT_APPLICABLE", "DUPLICATE_OBJECT", "CANNOT_UPDATE", "UNSUPPORTED_OPERATION", "CONCURRENT_MODIFICATION", "UNKNOWN"]}, :ConversionEvent=>{:type=>"string", :enumerations=>["UNKNOWN", "CREATIVE_VIEW", "START", "SKIP_SHOWN", "FIRST_QUARTILE", "MIDPOINT", "THIRD_QUARTILE", "ENGAGED_VIEW", "COMPLETE", "MUTE", "UNMUTE", "PAUSE", "REWIND", "RESUME", "SKIPPED", "FULLSCREEN", "EXPAND", "COLLAPSE", "ACCEPT_INVITATION", "CLOSE", "CLICK_TRACKING", "SURVEY", "CUSTOM_CLICK", "MEASURABLE_IMPRESSION", "VIEWABLE_IMPRESSION", "VIDEO_ABANDON", "FULLY_VIEWABLE_AUDIBLE_HALF_DURATION_IMPRESSION"]}, :"CreativeAssetMacroError.Reason"=>{:type=>"string", :enumerations=>["INVALID_MACRO_NAME", "UNKNOWN"]}, :"CreativeError.Reason"=>{:type=>"string", :enumerations=>["FLASH_AND_FALLBACK_URL_ARE_SAME", "INVALID_INTERNAL_REDIRECT_URL", "DESTINATION_URL_REQUIRED", "DESTINATION_URL_NOT_EMPTY", "DESTINATION_URL_TYPE_NOT_SUPPORTED", "CANNOT_CREATE_OR_UPDATE_LEGACY_DFP_CREATIVE", "CANNOT_CREATE_OR_UPDATE_LEGACY_DFP_MOBILE_CREATIVE", "MISSING_FEATURE", "INVALID_COMPANY_TYPE", "INVALID_ADSENSE_CREATIVE_SIZE", "INVALID_AD_EXCHANGE_CREATIVE_SIZE", "DUPLICATE_ASSET_IN_CREATIVE", "CREATIVE_ASSET_CANNOT_HAVE_ID_AND_BYTE_ARRAY", "CANNOT_CREATE_OR_UPDATE_UNSUPPORTED_CREATIVE", "CANNOT_CREATE_PROGRAMMATIC_CREATIVES", "INVALID_SIZE_FOR_THIRD_PARTY_IMPRESSION_TRACKER", "CANNOT_DEACTIVATE_CREATIVES_IN_CREATIVE_SETS", "UNKNOWN"]}, :CreativePolicyViolation=>{:type=>"string", :enumerations=>["MALWARE_IN_CREATIVE", "MALWARE_IN_LANDING_PAGE", "LEGALLY_BLOCKED_REDIRECT_URL", "MISREPRESENTATION_OF_PRODUCT", "SELF_CLICKING_CREATIVE", "GAMING_GOOGLE_NETWORK", "DYNAMIC_DNS", "CIRCUMVENTING_SYSTEMS", "PHISHING", "DOWNLOAD_PROMPT_IN_CREATIVE", "UNAUTHORIZED_COOKIE_DETECTED", "TEMPORARY_PAUSE_FOR_VENDOR_INVESTIGATION", "ABUSIVE_EXPERIENCE", "TRICK_TO_CLICK", "USE_OF_NON_ALLOWLISTED_OMID_VERIFICATION_SCRIPT", "MISUSE_OF_OMID_API", "UNACCEPTABLE_HTML_AD", "UNKNOWN"]}, :"CreativeSetError.Reason"=>{:type=>"string", :enumerations=>["VIDEO_FEATURE_REQUIRED", "CANNOT_CREATE_OR_UPDATE_VIDEO_CREATIVES", "ROADBLOCK_FEATURE_REQUIRED", "MASTER_CREATIVE_CANNOT_BE_COMPANION", "INVALID_ADVERTISER", "UPDATE_MASTER_CREATIVE_NOT_ALLOWED", "MASTER_CREATIVE_CANNOT_BELONG_TO_MULTIPLE_VIDEO_CREATIVE_SETS", "SKIPPABLE_AD_TYPE_NOT_ALLOWED", "UNKNOWN"]}, :"CreativeTemplateError.Reason"=>{:type=>"string", :enumerations=>["CANNOT_PARSE_CREATIVE_TEMPLATE", "VARIABLE_DUPLICATE_UNIQUE_NAME", "VARIABLE_INVALID_UNIQUE_NAME", "LIST_CHOICE_DUPLICATE_VALUE", "LIST_CHOICE_NEEDS_DEFAULT", "LIST_CHOICES_EMPTY", "NO_TARGET_PLATFORMS", "MULTIPLE_TARGET_PLATFORMS", "UNRECOGNIZED_PLACEHOLDER", "PLACEHOLDERS_NOT_IN_FORMATTER", "MISSING_INTERSTITIAL_MACRO", "UNKNOWN"]}, :"CreativeTemplateOperationError.Reason"=>{:type=>"string", :enumerations=>["NOT_ALLOWED", "NOT_APPLICABLE", "UNKNOWN"]}, :"CustomCreativeError.Reason"=>{:type=>"string", :enumerations=>["DUPLICATE_MACRO_NAME_FOR_CREATIVE", "SNIPPET_REFERENCES_MISSING_MACRO", "UNRECOGNIZED_MACRO", "CUSTOM_CREATIVE_NOT_ALLOWED", "MISSING_INTERSTITIAL_MACRO", "DUPLICATE_ASSET_IN_MACROS", "UNKNOWN"]}, :"CustomFieldValueError.Reason"=>{:type=>"string", :enumerations=>["CUSTOM_FIELD_NOT_FOUND", "CUSTOM_FIELD_INACTIVE", "CUSTOM_FIELD_OPTION_NOT_FOUND", "UNKNOWN"]}, :DeclarationType=>{:type=>"string", :enumerations=>["NONE", "DECLARED", "UNKNOWN"]}, :DestinationUrlType=>{:type=>"string", :enumerations=>["UNKNOWN", "CLICK_TO_WEB", "CLICK_TO_APP", "CLICK_TO_CALL", "NONE"]}, :"EntityLimitReachedError.Reason"=>{:type=>"string", :enumerations=>["CUSTOM_TARGETING_VALUES_LIMIT_REACHED", "AD_EXCLUSION_RULES_LIMIT_REACHED", "FIRST_PARTY_AUDIENCE_SEGMENTS_LIMIT_REACHED", "PLACEMENTS_LIMIT_REACHED", "LINE_ITEMS_LIMIT_REACHED", "ACTIVE_LINE_ITEMS_LIMIT_REACHED", "DAI_ENCODING_PROFILES_LIMIT_REACHED", "TRAFFIC_FORECAST_SEGMENTS_LIMIT_REACHED", "FORECAST_ADJUSTMENTS_LIMIT_REACHED", "ACTIVE_EXPERIMENTS_LIMIT_REACHED", "SITES_LIMIT_REACHED", "UNKNOWN"]}, :"FeatureError.Reason"=>{:type=>"string", :enumerations=>["MISSING_FEATURE", "UNKNOWN"]}, :"FileError.Reason"=>{:type=>"string", :enumerations=>["MISSING_CONTENTS", "SIZE_TOO_LARGE", "UNKNOWN"]}, :"HtmlBundleProcessorError.Reason"=>{:type=>"string", :enumerations=>["CANNOT_EXTRACT_FILES_FROM_BUNDLE", "CLICK_TAG_HARD_CODED", "CLICK_TAG_IN_GWD_UNUPPORTED", "CLICK_TAG_NOT_IN_PRIMARY_HTML", "CLICK_TAG_INVALID", "FILE_SIZE_TOO_LARGE", "FILES_TOO_MANY", "FLASH_UNSUPPORTED", "GWD_COMPONENTS_UNSUPPORTED", "GWD_ENABLER_METHODS_UNSUPPORTED", "GWD_PROPERTIES_INVALID", "LINKED_FILES_NOT_FOUND", "PRIMARY_HTML_MISSING", "PRIMARY_HTML_UNDETERMINED", "SVG_BLOCK_INVALID", "CANNOT_DECODE_BUNDLE", "UNKNOWN"]}, :ImageDensity=>{:type=>"string", :enumerations=>["ONE_TO_ONE", "THREE_TO_TWO", "TWO_TO_ONE", "UNKNOWN"]}, :"ImageError.Reason"=>{:type=>"string", :enumerations=>["INVALID_IMAGE", "INVALID_SIZE", "UNEXPECTED_SIZE", "OVERLAY_SIZE_TOO_LARGE", "ANIMATED_NOT_ALLOWED", "ANIMATION_TOO_LONG", "CMYK_JPEG_NOT_ALLOWED", "FLASH_NOT_ALLOWED", "FLASH_WITHOUT_CLICKTAG", "ANIMATED_VISUAL_EFFECT", "FLASH_ERROR", "LAYOUT_PROBLEM", "FLASH_HAS_NETWORK_OBJECTS", "FLASH_HAS_NETWORK_METHODS", "FLASH_HAS_URL", "FLASH_HAS_MOUSE_TRACKING", "FLASH_HAS_RANDOM_NUM", "FLASH_SELF_TARGETS", "FLASH_BAD_GETURL_TARGET", "FLASH_VERSION_NOT_SUPPORTED", "FILE_TOO_LARGE", "SYSTEM_ERROR", "UNEXPECTED_PRIMARY_ASSET_DENSITY", "DUPLICATE_ASSET_DENSITY", "MISSING_DEFAULT_ASSET", "UNKNOWN"]}, :"InternalApiError.Reason"=>{:type=>"string", :enumerations=>["UNEXPECTED_INTERNAL_API_ERROR", "TRANSIENT_ERROR", "UNKNOWN", "DOWNTIME", "ERROR_GENERATING_RESPONSE"]}, :"InvalidPhoneNumberError.Reason"=>{:type=>"string", :enumerations=>["INVALID_FORMAT", "TOO_SHORT", "UNKNOWN"]}, :"InvalidUrlError.Reason"=>{:type=>"string", :enumerations=>["ILLEGAL_CHARACTERS", "INVALID_FORMAT", "INSECURE_SCHEME", "NO_SCHEME", "UNKNOWN"]}, :"LabelEntityAssociationError.Reason"=>{:type=>"string", :enumerations=>["DUPLICATE_ASSOCIATION", "INVALID_ASSOCIATION", "NEGATION_NOT_ALLOWED", "DUPLICATE_ASSOCIATION_WITH_NEGATION", "UNKNOWN"]}, :"LineItemCreativeAssociationError.Reason"=>{:type=>"string", :enumerations=>["CREATIVE_IN_WRONG_ADVERTISERS_LIBRARY", "INVALID_LINEITEM_CREATIVE_PAIRING", "STARTDATE_BEFORE_LINEITEM_STARTDATE", "STARTDATE_NOT_BEFORE_LINEITEM_ENDDATE", "ENDDATE_AFTER_LINEITEM_ENDDATE", "ENDDATE_NOT_AFTER_LINEITEM_STARTDATE", "ENDDATE_NOT_AFTER_STARTDATE", "ENDDATE_IN_THE_PAST", "CANNOT_COPY_WITHIN_SAME_LINE_ITEM", "UNSUPPORTED_CREATIVE_VAST_REDIRECT_TYPE", "UNSUPPORTED_YOUTUBE_HOSTED_CREATIVE", "PROGRAMMATIC_CREATIVES_CAN_ONLY_BE_ASSIGNED_TO_ONE_LINE_ITEM", "CANNOT_ACTIVATE_ASSOCIATION_WITH_INACTIVE_CREATIVE", "CANNOT_CREATE_PROGRAMMATIC_CREATIVES", "CANNOT_UPDATE_PROGRAMMATIC_CREATIVES", "CREATIVE_AND_LINE_ITEM_MUST_BOTH_BE_SET_TOP_BOX_ENABLED", "CANNOT_DELETE_SET_TOP_BOX_ENABLED_ASSOCIATIONS", "SET_TOP_BOX_CREATIVE_ROTATION_WEIGHT_MUST_BE_INTEGER", "INVALID_CREATIVE_ROTATION_TYPE_FOR_MANUAL_WEIGHT", "CLICK_MACROS_REQUIRED", "VIEW_MACROS_NOT_ALLOWED", "UNKNOWN"]}, :LockedOrientation=>{:type=>"string", :enumerations=>["UNKNOWN", "FREE_ORIENTATION", "PORTRAIT_ONLY", "LANDSCAPE_ONLY"]}, :MimeType=>{:type=>"string", :enumerations=>["UNKNOWN", "ASP", "AUDIO_AIFF", "AUDIO_BASIC", "AUDIO_FLAC", "AUDIO_MID", "AUDIO_MP3", "AUDIO_MP4", "AUDIO_MPEG_URL", "AUDIO_MS_WMA", "AUDIO_OGG", "AUDIO_REAL_AUDIO_PLUGIN", "AUDIO_WAV", "BINARY", "DASH", "DIRECTOR", "FLASH", "GRAPHIC_CONVERTER", "JAVASCRIPT", "JSON", "IMAGE_BITMAP", "IMAGE_BMP", "IMAGE_GIF", "IMAGE_JPEG", "IMAGE_PHOTOSHOP", "IMAGE_PNG", "IMAGE_TIFF", "IMAGE_WBMP", "M3U8", "MAC_BIN_HEX_40", "MS_EXCEL", "MS_POWERPOINT", "MS_WORD", "OCTET_STREAM", "PDF", "POSTSCRIPT", "RN_REAL_MEDIA", "RFC_822", "RTF", "TEXT_CALENDAR", "TEXT_CSS", "TEXT_CSV", "TEXT_HTML", "TEXT_JAVA", "TEXT_PLAIN", "VIDEO_3GPP", "VIDEO_3GPP2", "VIDEO_AVI", "VIDEO_FLV", "VIDEO_MP4", "VIDEO_MP4V_ES", "VIDEO_MPEG", "VIDEO_MS_ASF", "VIDEO_MS_WM", "VIDEO_MS_WMV", "VIDEO_MS_WVX", "VIDEO_OGG", "VIDEO_QUICKTIME", "VIDEO_WEBM", "XAML", "XHTML", "XML", "ZIP"]}, :"NotNullError.Reason"=>{:type=>"string", :enumerations=>["ARG1_NULL", "ARG2_NULL", "ARG3_NULL", "NULL", "UNKNOWN"]}, :"NullError.Reason"=>{:type=>"string", :enumerations=>["NULL_CONTENT"]}, :"ParseError.Reason"=>{:type=>"string", :enumerations=>["UNPARSABLE", "UNKNOWN"]}, :"PermissionError.Reason"=>{:type=>"string", :enumerations=>["PERMISSION_DENIED", "UNKNOWN"]}, :"PublisherQueryLanguageContextError.Reason"=>{:type=>"string", :enumerations=>["UNEXECUTABLE", "UNKNOWN"]}, :"PublisherQueryLanguageSyntaxError.Reason"=>{:type=>"string", :enumerations=>["UNPARSABLE", "UNKNOWN"]}, :"QuotaError.Reason"=>{:type=>"string", :enumerations=>["EXCEEDED_QUOTA", "UNKNOWN", "REPORT_JOB_LIMIT"]}, :"RangeError.Reason"=>{:type=>"string", :enumerations=>["TOO_HIGH", "TOO_LOW", "UNKNOWN"]}, :"RequiredCollectionError.Reason"=>{:type=>"string", :enumerations=>["REQUIRED", "TOO_LARGE", "TOO_SMALL", "UNKNOWN"]}, :"RequiredError.Reason"=>{:type=>"string", :enumerations=>["REQUIRED"]}, :"RequiredNumberError.Reason"=>{:type=>"string", :enumerations=>["REQUIRED", "TOO_LARGE", "TOO_SMALL", "TOO_LARGE_WITH_DETAILS", "TOO_SMALL_WITH_DETAILS", "UNKNOWN"]}, :"RequiredSizeError.Reason"=>{:type=>"string", :enumerations=>["REQUIRED", "NOT_ALLOWED", "UNKNOWN"]}, :"RichMediaStudioChildAssetProperty.Type"=>{:type=>"string", :enumerations=>["FLASH", "VIDEO", "IMAGE", "DATA"]}, :RichMediaStudioCreativeArtworkType=>{:type=>"string", :enumerations=>["FLASH", "HTML5", "MIXED"]}, :RichMediaStudioCreativeBillingAttribute=>{:type=>"string", :enumerations=>["IN_PAGE", "FLOATING_EXPANDING", "VIDEO", "FLASH_IN_FLASH"]}, :"RichMediaStudioCreativeError.Reason"=>{:type=>"string", :enumerations=>["CREATION_NOT_ALLOWED", "UKNOWN_ERROR", "INVALID_CODE_GENERATION_REQUEST", "INVALID_CREATIVE_OBJECT", "STUDIO_CONNECTION_ERROR", "PUSHDOWN_DURATION_NOT_ALLOWED", "INVALID_POSITION", "INVALID_Z_INDEX", "INVALID_PUSHDOWN_DURATION", "UNKNOWN"]}, :RichMediaStudioCreativeFormat=>{:type=>"string", :enumerations=>["IN_PAGE", "EXPANDING", "IM_EXPANDING", "FLOATING", "PEEL_DOWN", "IN_PAGE_WITH_FLOATING", "FLASH_IN_FLASH", "FLASH_IN_FLASH_EXPANDING", "IN_APP", "UNKNOWN"]}, :ScalableType=>{:type=>"string", :enumerations=>["UNKNOWN", "NOT_SCALABLE", "RATIO_SCALABLE", "STRETCH_SCALABLE"]}, :"ServerError.Reason"=>{:type=>"string", :enumerations=>["SERVER_ERROR", "SERVER_BUSY", "UNKNOWN"]}, :"SetTopBoxCreativeError.Reason"=>{:type=>"string", :enumerations=>["EXTERNAL_ASSET_ID_IMMUTABLE", "EXTERNAL_ASSET_ID_REQUIRED", "PROVIDER_ID_IMMUTABLE", "UNKNOWN"]}, :SkippableAdType=>{:type=>"string", :enumerations=>["UNKNOWN", "DISABLED", "ENABLED", "INSTREAM_SELECT", "ANY"]}, :SslManualOverride=>{:type=>"string", :enumerations=>["UNKNOWN", "NO_OVERRIDE", "SSL_COMPATIBLE", "NOT_SSL_COMPATIBLE"]}, :SslScanResult=>{:type=>"string", :enumerations=>["UNKNOWN", "UNSCANNED", "SCANNED_SSL", "SCANNED_NON_SSL"]}, :"StatementError.Reason"=>{:type=>"string", :enumerations=>["VARIABLE_NOT_BOUND_TO_VALUE", "UNKNOWN"]}, :"StringFormatError.Reason"=>{:type=>"string", :enumerations=>["UNKNOWN", "ILLEGAL_CHARS", "INVALID_FORMAT"]}, :"StringLengthError.Reason"=>{:type=>"string", :enumerations=>["TOO_LONG", "TOO_SHORT", "UNKNOWN"]}, :"SwiffyConversionError.Reason"=>{:type=>"string", :enumerations=>["SERVER_ERROR", "INVALID_FLASH_FILE", "UNSUPPORTED_FLASH", "UNKNOWN"]}, :"TemplateInstantiatedCreativeError.Reason"=>{:type=>"string", :enumerations=>["INACTIVE_CREATIVE_TEMPLATE", "FILE_TYPE_NOT_ALLOWED", "UNKNOWN"]}, :VastRedirectType=>{:type=>"string", :enumerations=>["LINEAR", "NON_LINEAR", "LINEAR_AND_NON_LINEAR"]}, :VideoDeliveryType=>{:type=>"string", :enumerations=>["UNKNOWN", "PROGRESSIVE", "STREAMING"]}}
    CREATIVESERVICE_NAMESPACES = []

    def self.get_method_signature(method_name)
      return CREATIVESERVICE_METHODS[method_name.to_sym]
    end

    def self.get_type_signature(type_name)
      return CREATIVESERVICE_TYPES[type_name.to_sym]
    end

    def self.get_namespace(index)
      return CREATIVESERVICE_NAMESPACES[index]
    end
  end

  # Base class for exceptions.
  class ApplicationException < AdManagerApi::Errors::ApiException
    attr_reader :message  # string
  end

  # Exception class for holding a list of service errors.
  class ApiException < ApplicationException
    attr_reader :errors  # ApiError
    def initialize(exception_fault)
      @array_fields ||= []
      @array_fields << 'errors'
      super(exception_fault, CreativeServiceRegistry)
    end
  end
end; end; end
